#define sz 128
#define minuteScanRadius 40
#define hourScanRadius 30
#define angleThreshold 10 //     ,   

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

bool data[sz][sz];

// ,       angle ( ,  0  360)
//   radius  .
inline bool isPixelAtAngle(int radius, int angle)
{
    return data[(int) (sz / 2 - radius * cos(angle * M_PI / 180) + 0.5)]
               [(int) (sz / 2 + radius * sin(angle * M_PI / 180) + 0.5)];
}

// ,     angle ( ,  0  360)  
//  ,    ignoreAngle ( ,  0  360).
//  ignoreAngle < 0,      .
inline bool shouldBeIgnored(int angle, int ignoreAngle)
{
    if (ignoreAngle < 0)
        return false;
    return abs(angle - ignoreAngle) < angleThreshold
        || abs(angle + 360 - ignoreAngle) < angleThreshold
        || abs(angle - 360 - ignoreAngle) < angleThreshold;
}

// ĳ divident  divisor     .
int divide(int divident, int divisor)
{
    return (divident + divisor / 2) / divisor;
}

//     ,     radius  
//   .  ignoreAngle 䒺 ( ,  0  360), 
//  ,      .
//      ,  -1.
int scanForAngle(int radius, int ignoreAngle = -1)
{
    int angle = 0;
    while (isPixelAtAngle(radius, angle)) //       ,
        angle++;       //         360 
    int sum = 0, cnt = 0;
    for (int i = 0; i < 360; i++)
    {
        if (! shouldBeIgnored(angle % 360, ignoreAngle) && isPixelAtAngle(radius, angle))
        {
            sum += angle;
            cnt++;
        }
        angle++;
    }
    return cnt > 0 ? divide(sum, cnt) % 360 : -1;
}

int main()
{
    freopen("watcha.dat", "r", stdin);
    freopen("watcha.sol", "w", stdout);

    while (true)
    {
        char c;
        for (int i = 0; i < sz; i++)
        {
            for (int j = 0; j < sz; j++)
            {
                scanf("%c", &c);
                data[i][j] = c == '1';
            }
            scanf("\n");
        }

        int minuteAngle = scanForAngle(minuteScanRadius);
        int hourAngle = scanForAngle(hourScanRadius, minuteAngle);
        if (hourAngle < 0)
            hourAngle = minuteAngle;
        int wholeHourAngle = hourAngle - divide(minuteAngle, 12);
        if (wholeHourAngle < 0) //     
            wholeHourAngle += 360;
        int hour = divide(wholeHourAngle, 30);
        if (hour == 0)
            hour = 12;
        int minute = divide(minuteAngle, 6) % 60;

        printf("%d:%02d\n", hour, minute);

        if (scanf("%c", &c) <= 0)
            break;
    }

    return 0;
}
